"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MyTokens = void 0;
const react_1 = require("@chakra-ui/react");
const react_2 = __importStar(require("react"));
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const wallet_adapter_react_ui_1 = require("@solana/wallet-adapter-react-ui");
const react_3 = require("@strata-foundation/react");
const spl_token_1 = require("@solana/spl-token");
const react_4 = require("@strata-foundation/react");
const spl_utils_1 = require("@strata-foundation/spl-utils");
const TokenItem_1 = require("./TokenItem");
const MyTokens = () => {
    const { publicKey, connected } = (0, wallet_adapter_react_1.useWallet)();
    const { visible, setVisible } = (0, wallet_adapter_react_ui_1.useWalletModal)();
    const { provider } = (0, react_3.useProvider)();
    const [mints, setMints] = (0, react_2.useState)([]);
    (0, react_2.useEffect)(() => {
        function getTokenAccounts() {
            return __awaiter(this, void 0, void 0, function* () {
                if (!publicKey || !provider)
                    return;
                const accounts = yield provider.connection.getTokenAccountsByOwner(publicKey, { programId: spl_token_1.TOKEN_PROGRAM_ID });
                const m = accounts.value.map((acc) => { var _a; return ((_a = (0, react_4.TokenAccountParser)(acc.pubkey, acc.account)) === null || _a === void 0 ? void 0 : _a.info.mint); }).filter(spl_utils_1.truthy);
                setMints(m);
            });
        }
        getTokenAccounts();
    }, [publicKey, provider]);
    const [tokensRecord, setTokensRecord] = (0, react_2.useState)({});
    // TODO this intermediate token detection is flawed, if bonding curve is closed no way to detect which is the real token to display
    const isIntermediateToken = (0, react_2.useCallback)((mint, metadata, hasTokenBonding) => {
        function serialize(metadata) {
            return `${metadata.name} - ${metadata === null || metadata === void 0 ? void 0 : metadata.symbol}`;
        }
        const serial = serialize(metadata);
        if (serial in tokensRecord) {
            if (!tokensRecord[serial].has(mint.toString())) {
                tokensRecord[serial].add(mint.toString());
            }
            if (tokensRecord[serial].size > 1 && hasTokenBonding) {
                return true;
            }
            return false;
        }
        tokensRecord[serial] = new Set([mint.toString()]);
        return false;
    }, []);
    return (react_2.default.createElement(react_2.default.Fragment, null,
        react_2.default.createElement(react_1.Center, { padding: "54px", backgroundColor: "black.500" },
            react_2.default.createElement(react_1.Stack, { spacing: 6 },
                react_2.default.createElement(react_1.Text, { fontSize: "2xl", color: "white", textAlign: "center" },
                    "Welcome to",
                    react_2.default.createElement(react_1.Text, { fontWeight: "Bold", background: "linear-gradient(to right,#FFCD01, #E17E44);", backgroundClip: "text" }, "Strata Launchpad")))),
        react_2.default.createElement(react_1.Box, { w: "full", py: 12, bgColor: "gray.100" },
            react_2.default.createElement(react_1.Container, { maxW: "container.lg" },
                react_2.default.createElement(react_1.Stack, { spacing: 8, justifyContent: "center" },
                    react_2.default.createElement(react_1.Box, { position: "relative" },
                        !connected && (react_2.default.createElement(react_1.Flex, { position: "absolute", w: "full", h: "full", zIndex: "1", flexDirection: "column" },
                            react_2.default.createElement(react_1.Flex, { justifyContent: "center" },
                                react_2.default.createElement(react_1.Button, { colorScheme: "orange", variant: "outline", onClick: () => setVisible(!visible) }, "Connect Wallet")),
                            react_2.default.createElement(react_1.Flex, { w: "full", h: "full", bg: "gray.100", opacity: "0.6" }))),
                        react_2.default.createElement(react_1.Box, { w: "full" },
                            react_2.default.createElement(react_1.Text, { fontSize: "3xl", color: "black.500", fontWeight: "bold" }, "My Tokens"),
                            react_2.default.createElement(react_1.Flex, { w: "full", flexWrap: "wrap", marginTop: "2em" },
                                react_2.default.createElement(react_1.VStack, { w: "full", alignItems: "flex-start" }, mints.map((mint) => (react_2.default.createElement(TokenItem_1.TokenItem, { mint: mint, isIntermediateToken: isIntermediateToken, key: mint.toString() }))))))))))));
};
exports.MyTokens = MyTokens;
//# sourceMappingURL=MyTokens.js.map