"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteDisclaimer = void 0;
const react_1 = __importDefault(require("react"));
const react_2 = require("@chakra-ui/react");
const react_3 = require("@strata-foundation/react");
const SiteDisclaimer = () => {
    const { onClose } = (0, react_2.useDisclosure)();
    const [hasAcknowledged, setHasAcknowledged] = (0, react_3.useLocalStorage)("siteDisclaimerAcknowledged", false);
    const handleAcknowledge = () => {
        setHasAcknowledged(true);
    };
    return (react_1.default.createElement(react_2.Modal, { isOpen: !hasAcknowledged, onClose: onClose, size: "sm", isCentered: true },
        react_1.default.createElement(react_2.ModalOverlay, null),
        react_1.default.createElement(react_2.ModalContent, null,
            react_1.default.createElement(react_2.ModalBody, { pt: 4, color: (0, react_2.useColorModeValue)("black", "white") },
                react_1.default.createElement(react_2.Text, { fontWeight: "bold" }, "Site Disclaimer"),
                react_1.default.createElement(react_2.Text, { fontSize: "sm" }, "Please note that Strata protocol is maintained by the community, and no longer has a dedicted team. It is preserved as a utility to the community, but bug fixes are provided on a volunteer basis. It uses a free rpc node, so it may be slow or unresponse at times."),
                react_1.default.createElement(react_2.Text, { fontSize: "sm", mt: 4 },
                    "We strongly recommend that you fork ",
                    " ",
                    react_1.default.createElement("a", { href: "https://github.com/StrataFoundation/strata" }, "https://github.com/StrataFoundation/strata"),
                    " ",
                    "and deploy your own marketplace-ui, rather than using this website. The free rpc node could cause issues for your users. You should also consider employing a developer that understands the technology behind this application and can make changes to your token as needed."),
                react_1.default.createElement(react_2.Flex, { justifyContent: "center" },
                    react_1.default.createElement(react_2.Button, { variant: "ghost", colorScheme: "primary", onClick: handleAcknowledge, _hover: { bgColor: "transparent" } }, "I Accept"))))));
};
exports.SiteDisclaimer = SiteDisclaimer;
//# sourceMappingURL=SiteDisclaimer.js.map