"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenItem = void 0;
// @ts-nocheck
const react_1 = require("@chakra-ui/react");
const md_1 = require("react-icons/md");
const react_2 = __importStar(require("react"));
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const react_3 = require("@strata-foundation/react");
const router_1 = require("next/router");
const routes_1 = require("../utils/routes");
const TokenItem = ({ mint, isIntermediateToken }) => {
    const router = (0, router_1.useRouter)();
    const { publicKey } = (0, wallet_adapter_react_1.useWallet)();
    const { info: tokenBonding } = (0, react_3.useTokenBondingFromMint)(mint);
    const { image, data, data: metadata } = (0, react_3.useTokenMetadata)(mint);
    const hasAnyAuth = (0, react_2.useMemo)(() => {
        var _a;
        return publicKey && tokenBonding && (tokenBonding.reserveAuthority.equals(publicKey) ||
            ((_a = tokenBonding.generalAuthority) === null || _a === void 0 ? void 0 : _a.equals(publicKey)));
    }, [publicKey, tokenBonding]);
    // @ts-ignore
    const shouldDisplay = mint && metadata && hasAnyAuth ? !isIntermediateToken(mint, metadata, !!tokenBonding) : false;
    return (react_2.default.createElement(react_2.default.Fragment, null, shouldDisplay && (react_2.default.createElement(react_1.Flex, { bgColor: "white", borderRadius: "8px", w: "full", h: "7em", alignItems: "center", mb: "10px !important" },
        react_2.default.createElement(react_1.Flex, { onClick: () => {
                router.push((0, routes_1.route)(routes_1.routes.tokenAdmin, {
                    mintKey: mint.toString(),
                }), undefined, { shallow: true });
            }, cursor: "pointer", alignItems: "center" },
            react_2.default.createElement(react_1.Image, { alt: "Token logo", marginLeft: "2em", w: "50px", h: "50px", borderRadius: "50%", src: image }),
            react_2.default.createElement(react_1.Text, { fontSize: "xl", textAlign: "left", fontWeight: "bold", paddingLeft: "10px" }, data === null || data === void 0 ? void 0 : data.name)),
        react_2.default.createElement(react_1.Flex, { marginLeft: "auto", onClick: () => {
                router.push((0, routes_1.route)(routes_1.routes.tokenAdmin, {
                    mintKey: mint.toString(),
                }), undefined, { shallow: true });
            }, cursor: "pointer" },
            react_2.default.createElement(react_1.Text, { marginRight: "10px" }, "Manage Token"),
            react_2.default.createElement(react_1.Icon, { w: "24px", h: "24px", as: md_1.MdSettings, marginRight: "2em" }))))));
};
exports.TokenItem = TokenItem;
//# sourceMappingURL=TokenItem.js.map