"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LaunchPreview = void 0;
// @ts-nocheck
const react_1 = require("@chakra-ui/react");
const react_2 = __importStar(require("react"));
const react_3 = require("@strata-foundation/react");
const md_1 = require("react-icons/md");
const router_1 = require("next/router");
const routes_1 = require("../../utils/routes");
const spl_token_bonding_1 = require("@strata-foundation/spl-token-bonding");
function checkIsFixedPrice(curve) {
    var _a, _b, _c, _d, _e;
    const fixedPriceCurveConfig = new spl_token_bonding_1.ExponentialCurveConfig({
        c: 0,
        pow: 0,
        frac: 1,
    }).toRawConfig();
    //@ts-ignore
    const hasOneCurve = ((_b = (_a = curve.definition) === null || _a === void 0 ? void 0 : _a.timeV0) === null || _b === void 0 ? void 0 : _b.curves) && curve.definition.timeV0.curves.length == 1;
    if (!hasOneCurve)
        return false;
    //@ts-ignore
    const expCurve = (_d = (_c = curve.definition.timeV0.curves[0]) === null || _c === void 0 ? void 0 : _c.curve) === null || _d === void 0 ? void 0 : _d.exponentialCurveV0;
    const isFixedCurve = expCurve && ((_e = expCurve.c) === null || _e === void 0 ? void 0 : _e.toNumber()) === 0 && expCurve.pow === 0 && expCurve.frac === 1;
    return !!isFixedCurve;
}
const LaunchPreview = ({ id, name, image }) => {
    const { tokenBonding, entangled } = (0, react_3.useTokenSwapFromId)(id);
    const reserveAmount = (0, react_3.useReserveAmount)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey);
    const { metadata } = (0, react_3.useMetaplexTokenMetadata)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.baseMint);
    const router = (0, router_1.useRouter)();
    const { cluster } = (0, react_3.useEndpoint)();
    const { info: curve } = (0, react_3.useCurve)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.curve);
    const [isFixedPrice, isFullyManaged] = (0, react_2.useMemo)(() => {
        if (tokenBonding && curve) {
            const isFixed = checkIsFixedPrice(curve);
            if (isFixed)
                return [true, false]; // fixed price
            if (!entangled)
                return [false, true]; // fully managed
        }
        return [false, false];
    }, [tokenBonding, curve]);
    const docsUrl = (0, react_2.useMemo)(() => {
        if (isFixedPrice) {
            return (0, routes_1.route)(routes_1.routes.fixedPriceAdmin, {
                id: id === null || id === void 0 ? void 0 : id.toString(),
                cluster,
            });
        }
        if (isFullyManaged) {
            return (0, routes_1.route)(routes_1.routes.fullyManagedAdmin, {
                id: id === null || id === void 0 ? void 0 : id.toString(),
                cluster,
            });
        }
        return (0, routes_1.route)(routes_1.routes.tokenLbcAdmin, {
            id: id === null || id === void 0 ? void 0 : id.toString(),
            cluster,
        });
    }, [isFixedPrice, isFullyManaged]);
    return (react_2.default.createElement(react_1.Flex, { alignItems: "center", w: "full" },
        react_2.default.createElement(react_1.Image, { alt: "Token logo", marginLeft: "2em", w: "50px", h: "50px", borderRadius: "50%", src: image }),
        react_2.default.createElement(react_1.Stack, { paddingLeft: "10px", onClick: () => window.open(docsUrl, "_blank"), cursor: "pointer" },
            react_2.default.createElement(react_1.Text, { fontSize: "xl", textAlign: "left", fontWeight: "bold" }, name),
            react_2.default.createElement(react_1.Text, { fontSize: "md", marginTop: "0 !important" },
                "Amount raised: ",
                reserveAmount,
                " ", metadata === null || metadata === void 0 ? void 0 :
                metadata.data.symbol)),
        react_2.default.createElement(react_1.Icon, { w: "24px", h: "24px", as: md_1.MdSettings, onClick: () => window.open(docsUrl, "_blank"), cursor: "pointer", marginLeft: "auto", marginRight: "2em" })));
};
exports.LaunchPreview = LaunchPreview;
//# sourceMappingURL=LaunchPreview.js.map