"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SellTokensButton = void 0;
const react_1 = require("@chakra-ui/react");
const icons_1 = require("@chakra-ui/icons");
const react_2 = __importDefault(require("react"));
const router_1 = require("next/router");
const routes_1 = require("../../utils/routes");
const SellTokensButton = ({ mintKey }) => {
    const router = (0, router_1.useRouter)();
    return (react_2.default.createElement(react_1.Box, { bgColor: "black.500", color: "white", borderRadius: "8px", padding: "30px", mb: "10px !important" },
        react_2.default.createElement(react_1.Image, { src: "/swap.png", h: "70px", marginBottom: "20px" }),
        react_2.default.createElement(react_1.Text, { fontSize: "lg", fontWeight: "bold" }, "Sell Existing Token"),
        react_2.default.createElement(react_1.Text, { fontSize: "md" }, "You already have a token created that you would like to sell."),
        react_2.default.createElement(react_1.Button, { bgColor: "black.500", rightIcon: react_2.default.createElement(icons_1.ArrowForwardIcon, { color: "#f07733" }), _hover: { bg: "black.500" }, _active: { bg: "black.500" }, padding: "0", marginTop: "20px", onClick: () => {
                router.push((0, routes_1.route)(routes_1.routes.sell, {
                    mint: mintKey === null || mintKey === void 0 ? void 0 : mintKey.toString(),
                }), undefined, { shallow: true });
            } }, "Start")));
};
exports.SellTokensButton = SellTokensButton;
//# sourceMappingURL=SellTokensButton.js.map