"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenAdmin = void 0;
const react_1 = require("@chakra-ui/react");
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const wallet_adapter_react_ui_1 = require("@solana/wallet-adapter-react-ui");
const router_1 = require("next/router");
const react_2 = require("@strata-foundation/react");
const TokenPreview_1 = require("./TokenPreview");
const TokenLaunches_1 = require("./TokenLaunches");
const TokenAuthorityForm_1 = require("../form/TokenAuthorityForm");
const MintTokensWidget_1 = require("./MintTokensWidget");
const SellTokensButton_1 = require("./SellTokensButton");
const routes_1 = require("../../utils/routes");
const react_3 = __importDefault(require("react"));
const TokenAdmin = () => {
    const { connected } = (0, wallet_adapter_react_1.useWallet)();
    const { visible, setVisible } = (0, wallet_adapter_react_ui_1.useWalletModal)();
    const router = (0, router_1.useRouter)();
    const { mintKey: mintKeyRaw } = router.query;
    const mintKey = (0, react_2.usePublicKey)(mintKeyRaw);
    const { metadata, mint, data, image } = (0, react_2.useTokenMetadata)(mintKey);
    return (react_3.default.createElement(react_3.default.Fragment, null,
        react_3.default.createElement(react_1.Center, { padding: "54px", backgroundColor: "black.500" },
            react_3.default.createElement(react_1.Container, { maxW: "container.lg", display: "flex", justifyContent: "space-between" },
                react_3.default.createElement(TokenPreview_1.TokenPreview, { data: data, image: image }),
                react_3.default.createElement(react_1.Button, { borderColor: "primary.500", color: "white", variant: "outline", onClick: () => {
                        router.push((0, routes_1.route)(routes_1.routes.editMetadata, {
                            mintKey: mintKey === null || mintKey === void 0 ? void 0 : mintKey.toString(),
                        }), undefined, { shallow: true });
                    } }, "Edit"))),
        react_3.default.createElement(react_1.Box, { w: "full", py: 12, bgColor: "gray.100" },
            react_3.default.createElement(react_1.Container, { maxW: "container.lg" },
                react_3.default.createElement(react_1.Stack, { spacing: 8, justifyContent: "center" },
                    react_3.default.createElement(react_1.Box, { position: "relative" },
                        !connected && (react_3.default.createElement(react_1.Flex, { position: "absolute", w: "full", h: "full", zIndex: "1", flexDirection: "column" },
                            react_3.default.createElement(react_1.Flex, { justifyContent: "center" },
                                react_3.default.createElement(react_1.Button, { colorScheme: "orange", variant: "outline", onClick: () => setVisible(!visible) }, "Connect Wallet")),
                            react_3.default.createElement(react_1.Flex, { w: "full", h: "full", bg: "gray.100", opacity: "0.6" }))),
                        react_3.default.createElement(react_1.Box, { w: "full" },
                            react_3.default.createElement(react_1.Text, { fontSize: "3xl", color: "black.500", fontWeight: "bold" }, "Admin Settings"),
                            react_3.default.createElement(react_1.Flex, { w: "full", flexWrap: "wrap", marginTop: "2em" },
                                react_3.default.createElement(react_1.VStack, { w: { base: "100%", md: "65%" }, alignItems: "flex-start" },
                                    react_3.default.createElement(react_1.Text, { fontSize: "xl", color: "black.500", fontWeight: "bold" }, "Launches"),
                                    react_3.default.createElement(TokenLaunches_1.TokenLaunches, { mintKey: mintKey, name: data === null || data === void 0 ? void 0 : data.name, image: image }),
                                    react_3.default.createElement(react_1.Text, { fontSize: "xl", color: "black.500", fontWeight: "bold", pt: "20px", pb: "20px" }, "Authority Preferences"),
                                    react_3.default.createElement(TokenAuthorityForm_1.TokenAuthorityForm, { values: {}, metadata: metadata, mint: mint, mintKey: mintKey })),
                                react_3.default.createElement(react_1.VStack, { w: { base: "100%", md: "35%" }, alignItems: "flex-start", paddingLeft: "30px" },
                                    react_3.default.createElement(react_1.Text, { fontSize: "xl", color: "black.500", fontWeight: "bold" }, "Token Actions"),
                                    react_3.default.createElement(SellTokensButton_1.SellTokensButton, { mintKey: mintKey }),
                                    react_3.default.createElement(MintTokensWidget_1.MintTokensWidget, { values: {}, mintKey: mintKey, mint: mint }))))))))));
};
exports.TokenAdmin = TokenAdmin;
//# sourceMappingURL=TokenAdmin.js.map