"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TokenLaunches = void 0;
const react_1 = require("@chakra-ui/react");
const react_2 = require("@strata-foundation/react");
const LaunchPreview_1 = require("./LaunchPreview");
const react_3 = __importStar(require("react"));
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const react_async_hook_1 = require("react-async-hook");
const fungible_entangler_1 = require("@strata-foundation/fungible-entangler");
const TokenLaunches = ({ mintKey, name, image }) => {
    const { publicKey } = (0, wallet_adapter_react_1.useWallet)();
    const [parsed, setParsed] = (0, react_3.useState)([]);
    const { fungibleEntanglerSdk } = (0, react_2.useStrataSdks)();
    const { info: tokenBonding } = (0, react_2.useTokenBondingFromMint)(mintKey);
    const { info: entangler } = (0, react_2.useFungibleChildEntangler)(parsed[0]);
    (0, react_async_hook_1.useAsync)(() => __awaiter(void 0, void 0, void 0, function* () {
        if (!mintKey || !fungibleEntanglerSdk)
            return;
        const parentAccounts = yield (fungibleEntanglerSdk === null || fungibleEntanglerSdk === void 0 ? void 0 : fungibleEntanglerSdk.provider.connection.getProgramAccounts(fungible_entangler_1.FungibleEntangler.ID, {
            filters: [
                {
                    memcmp: {
                        offset: 8,
                        bytes: (mintKey === null || mintKey === void 0 ? void 0 : mintKey.toBase58()) || "",
                    },
                },
            ]
        }));
        if (parentAccounts && parentAccounts.length) {
            const parsedParents = parentAccounts.map((acc) => {
                return fungibleEntanglerSdk === null || fungibleEntanglerSdk === void 0 ? void 0 : fungibleEntanglerSdk.parentEntanglerDecoder(acc.pubkey, acc.account);
            }).filter((acc) => {
                var _a;
                return (_a = acc === null || acc === void 0 ? void 0 : acc.authority) === null || _a === void 0 ? void 0 : _a.equals(publicKey);
            });
            const parsed = yield Promise.all(parsedParents.map((acc) => __awaiter(void 0, void 0, void 0, function* () {
                const childEntanglers = yield (fungibleEntanglerSdk === null || fungibleEntanglerSdk === void 0 ? void 0 : fungibleEntanglerSdk.provider.connection.getProgramAccounts(fungible_entangler_1.FungibleEntangler.ID, {
                    filters: [
                        {
                            memcmp: {
                                offset: 8,
                                bytes: acc.publicKey.toString() || "",
                            }
                        }
                    ]
                }));
                return childEntanglers === null || childEntanglers === void 0 ? void 0 : childEntanglers.map((child) => child.pubkey).filter(react_2.truthy);
            })));
            if (parsed[0]) {
                setParsed(parsed[0]);
            }
            return;
        }
        setParsed([]);
    }), [mintKey, fungibleEntanglerSdk, entangler]);
    return (react_3.default.createElement(react_1.Box, { w: "full" }, tokenBonding ? (react_3.default.createElement(react_1.Flex, { bgColor: "white", borderRadius: "8px", w: "full", h: "7em" },
        react_3.default.createElement(LaunchPreview_1.LaunchPreview, { id: mintKey, name: name, image: image }))) : parsed.length ? (parsed.map((val) => (react_3.default.createElement(react_1.Flex, { bgColor: "white", borderRadius: "8px", w: "full", h: "7em", mb: "15px", key: val.toString() },
        react_3.default.createElement(LaunchPreview_1.LaunchPreview, { id: val, name: name, image: image }))))) : (react_3.default.createElement(react_1.Flex, { bgColor: "white", borderRadius: "8px", w: "full", h: "7em" },
        react_3.default.createElement(react_1.Text, { alignSelf: "center", ml: "20px" }, "No current token offerings.")))));
};
exports.TokenLaunches = TokenLaunches;
//# sourceMappingURL=TokenLaunches.js.map