"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RoyaltiesInputs = exports.percentOr = exports.humanReadablePercentage = void 0;
const react_1 = __importDefault(require("react"));
const react_2 = require("@chakra-ui/react");
const humanReadablePercentage = (u32) => {
    if (u32 && u32 !== 0) {
        return ((u32 / 4294967295) * 100).toFixed(2);
    }
    return 0;
};
exports.humanReadablePercentage = humanReadablePercentage;
function percentOr(percentu32, def) {
    return percentu32 ? Number((0, exports.humanReadablePercentage)(percentu32)) : def;
}
exports.percentOr = percentOr;
const RoyaltiesInputs = ({ symbol, baseSymbol, register, minBuyTargetRoyaltyPercentage, maxBuyTargetRoyaltyPercentage, minSellTargetRoyaltyPercentage, maxSellTargetRoyaltyPercentage, minBuyBaseRoyaltyPercentage, maxBuyBaseRoyaltyPercentage, minSellBaseRoyaltyPercentage, maxSellBaseRoyaltyPercentage, }) => {
    return (react_1.default.createElement(react_2.VStack, { align: "left", w: "full" },
        react_1.default.createElement(react_2.Heading, { fontSize: "xl", mb: 4 }, "Royalties"),
        react_1.default.createElement(react_2.HStack, null,
            react_1.default.createElement(react_2.FormControl, { id: "buyTargetRoyaltyPercentage", borderColor: "gray.200" },
                react_1.default.createElement(react_2.FormLabel, null,
                    symbol || "Managed Token",
                    " (Buy)"),
                react_1.default.createElement(react_2.Input, Object.assign({ isRequired: true, type: "number", min: percentOr(minBuyTargetRoyaltyPercentage, 0), max: percentOr(maxBuyTargetRoyaltyPercentage, 100), placeholder: "5", defaultValue: 5, step: 0.00001 }, register("buyTargetRoyaltyPercentage")))),
            react_1.default.createElement(react_2.FormControl, { id: "sellTargetRoyaltyPercentage", borderColor: "gray.200" },
                react_1.default.createElement(react_2.FormLabel, null,
                    symbol || "Managed Token",
                    " (Sell)"),
                react_1.default.createElement(react_2.Input, Object.assign({ isRequired: true, type: "number", min: percentOr(minSellTargetRoyaltyPercentage, 0), max: percentOr(maxSellTargetRoyaltyPercentage, 100), placeholder: "0", defaultValue: 0, step: 0.00001 }, register("sellTargetRoyaltyPercentage"))))),
        react_1.default.createElement(react_2.HStack, null,
            react_1.default.createElement(react_2.FormControl, { id: "buyBaseRoyaltyPercentage", borderColor: "gray.200" },
                react_1.default.createElement(react_2.FormLabel, null,
                    baseSymbol || "Base Token",
                    " (Buy)"),
                react_1.default.createElement(react_2.Input, Object.assign({ isRequired: true, type: "number", min: percentOr(minBuyBaseRoyaltyPercentage, 0), max: percentOr(maxBuyBaseRoyaltyPercentage, 100), placeholder: "0", defaultValue: 0, step: 0.00001 }, register("buyBaseRoyaltyPercentage")))),
            react_1.default.createElement(react_2.FormControl, { id: "sellBaseRoyaltyPercentage", borderColor: "gray.200" },
                react_1.default.createElement(react_2.FormLabel, null,
                    baseSymbol || "Base Token",
                    " (Sell)"),
                react_1.default.createElement(react_2.Input, Object.assign({ isRequired: true, type: "number", min: percentOr(minSellBaseRoyaltyPercentage, 0), max: percentOr(maxSellBaseRoyaltyPercentage, 100), placeholder: "0", defaultValue: 0, step: 0.00001 }, register("sellBaseRoyaltyPercentage"))))),
        react_1.default.createElement(react_2.FormControl, null,
            react_1.default.createElement(react_2.FormHelperText, null, "A Percentage of coin buys/sales that will be sent to your wallet. We recommend to keep this less than a combined 10% for buys/sales."))));
};
exports.RoyaltiesInputs = RoyaltiesInputs;
//# sourceMappingURL=RoyaltiesInputs.js.map