"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LbcInfo = exports.BigText = exports.BlackBox = void 0;
// @ts-nocheck
const react_1 = require("@chakra-ui/react");
const react_2 = require("@strata-foundation/react");
const react_3 = __importStar(require("react"));
const react_circular_progressbar_1 = require("react-circular-progressbar");
const useLivePrice_1 = require("../..//hooks/useLivePrice");
const numberWithCommas_1 = require("../../utils/numberWithCommas");
const ri_1 = require("react-icons/ri");
const react_countdown_1 = __importDefault(require("react-countdown"));
const BlackBox = (_a) => {
    var { children } = _a, other = __rest(_a, ["children"]);
    return (react_3.default.createElement(react_1.Box, Object.assign({ p: 4, rounded: "lg", backgroundColor: (0, react_1.useColorModeValue)("gray.200", "black.500") }, other), children));
};
exports.BlackBox = BlackBox;
const BigText = (_a) => {
    var { children } = _a, other = __rest(_a, ["children"]);
    return (react_3.default.createElement(react_1.Text, Object.assign({ fontWeight: "semibold", fontSize: "xl" }, other), children));
};
exports.BigText = BigText;
const LbcInfo = ({ id, useTokenOfferingCurve = false, price: inputPrice, }) => {
    const { isOpen, onToggle } = (0, react_1.useDisclosure)({
        defaultIsOpen: false,
    });
    const { tokenBonding, numRemaining, loading: loadingBonding, } = (0, react_2.useTokenSwapFromId)(id);
    const { price, loading: loadingPricing } = (0, useLivePrice_1.useLivePrice)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey);
    const { mintCap } = (0, react_2.useCapInfo)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.publicKey, useTokenOfferingCurve);
    const priceToUse = inputPrice || price;
    const { info: curve } = (0, react_2.useCurve)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.curve);
    const maxTime = 
    // @ts-ignore
    curve === null || curve === void 0 ? void 0 : curve.definition.timeV0.curves[0].curve.timeDecayExponentialCurveV0.interval;
    const unixTime = (0, react_2.useSolanaUnixTime)();
    const [elapsedTime, setElapsedTime] = (0, react_3.useState)();
    (0, react_3.useEffect)(() => {
        setElapsedTime(tokenBonding
            ? (unixTime || new Date().valueOf() / 1000) -
                tokenBonding.goLiveUnixTime.toNumber()
            : undefined);
    }, [unixTime]);
    const endDate = new Date(0);
    endDate.setUTCSeconds(((tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.goLiveUnixTime.toNumber()) || 0) + (maxTime || 0));
    const isLive = tokenBonding && unixTime
        ? tokenBonding.goLiveUnixTime.toNumber() < unixTime
        : false;
    const { metadata } = (0, react_2.useMetaplexTokenMetadata)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.baseMint);
    const { metadata: targetMeta } = (0, react_2.useMetaplexTokenMetadata)(tokenBonding === null || tokenBonding === void 0 ? void 0 : tokenBonding.targetMint);
    const renderer = ({ days, hours, minutes, seconds, completed, }) => {
        if (completed) {
            return react_3.default.createElement(exports.BigText, null, "Finished");
        }
        return (react_3.default.createElement(exports.BigText, null,
            days ? `${days} Days, ` : "",
            `${hours}`.padStart(2, "0"),
            ":",
            `${minutes}`.padStart(2, "0"),
            ":",
            `${seconds}`.padStart(2, "0")));
    };
    return (react_3.default.createElement(react_1.VStack, { spacing: 4, align: "stretch", justify: "stretch" },
        react_3.default.createElement(react_1.VStack, { align: "stretch", justify: "stretch" },
            react_3.default.createElement(exports.BlackBox, { w: "full" },
                react_3.default.createElement(react_1.VStack, { align: "left", spacing: 0 },
                    react_3.default.createElement(react_1.HStack, { spacing: 1, position: "relative" },
                        react_3.default.createElement(react_1.Text, { fontSize: "sm" }, "Time Remaining"),
                        react_3.default.createElement(react_1.Box, { w: "14px", h: "14px" },
                            react_3.default.createElement(react_circular_progressbar_1.CircularProgressbar, { counterClockwise: true, value: elapsedTime && maxTime
                                    ? ((maxTime - elapsedTime) / maxTime) * 100
                                    : 0, strokeWidth: 50, styles: (0, react_circular_progressbar_1.buildStyles)({
                                    strokeLinecap: "butt",
                                    trailColor: "transparent",
                                    pathColor: "rgba(255, 255, 255, 0.36)",
                                }) }))),
                    isLive ? (
                    // @ts-ignore
                    react_3.default.createElement(react_countdown_1.default, { date: endDate, now: () => (unixTime ? unixTime * 1000 : new Date().valueOf()), renderer: renderer })) : (react_3.default.createElement(exports.BigText, null, "Not Started")))),
            react_3.default.createElement(react_1.Stack, { direction: ["column", "row"], justify: "stretch" },
                react_3.default.createElement(exports.BlackBox, { w: "full", position: "relative" },
                    react_3.default.createElement(react_1.VStack, { align: "left", spacing: 0 },
                        react_3.default.createElement(react_1.HStack, { spacing: 2 },
                            react_3.default.createElement(react_1.Text, { fontSize: "sm" }, "Price"),
                            react_3.default.createElement(react_1.Tooltip, { hasArrow: true, label: "Dynamic Pricing is similiar to a Dutch Auction. The price starts\n              high, lowers gradually, and only increases when people buy. This\n              price discovery mechanism is powered by a Strata Liquidity\n              Bootstrapping Curve (LBC)" },
                                react_3.default.createElement(react_1.Center, null,
                                    react_3.default.createElement(react_1.Icon, { w: 4, h: 4, as: ri_1.RiInformationFill })))),
                        loadingPricing || typeof priceToUse == "undefined" ? (react_3.default.createElement(react_1.Spinner, { size: "lg" })) : (react_3.default.createElement(exports.BigText, null, isNaN(priceToUse)
                            ? "Not Started"
                            : (metadata === null || metadata === void 0 ? void 0 : metadata.data.symbol) === "USDC"
                                ? `$${(0, numberWithCommas_1.numberWithCommas)(priceToUse, 2)}`
                                : `${(0, numberWithCommas_1.numberWithCommas)(priceToUse, 4)} ${metadata === null || metadata === void 0 ? void 0 : metadata.data.symbol}`)))),
                react_3.default.createElement(exports.BlackBox, { w: "full", position: "relative" },
                    react_3.default.createElement(react_1.VStack, { spacing: 0, align: "left" },
                        react_3.default.createElement(react_1.Text, { fontSize: "sm" }, "Remaining"),
                        loadingBonding ? (react_3.default.createElement(react_1.Spinner, null)) : (react_3.default.createElement(exports.BigText, null,
                            numRemaining ? (0, numberWithCommas_1.numberWithCommas)(numRemaining, 4) : "0",
                            " ", targetMeta === null || targetMeta === void 0 ? void 0 :
                            targetMeta.data.symbol)),
                        react_3.default.createElement(react_1.Progress, { w: "88%", size: "xs", h: "2px", position: "absolute", bottom: "8px", colorScheme: "primary", background: "rgba(196, 196, 196, 0.4)", value: ((numRemaining || 0) / (mintCap || 0)) * 100 })))))));
};
exports.LbcInfo = LbcInfo;
//# sourceMappingURL=LbcInfo.js.map