"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MintedNftNotification = void 0;
const react_1 = __importDefault(require("react"));
const react_2 = require("@chakra-ui/react");
const react_3 = require("@strata-foundation/react");
const MintedNftNotification = ({ onDismiss, mint, }) => {
    const { metadata, image, loading } = (0, react_3.useMetaplexTokenMetadata)(mint);
    return (react_1.default.createElement(react_2.Alert, { w: "full", bgColor: (0, react_2.useColorModeValue)("white", "black.300"), borderTop: "1px", borderTopColor: "gray.600", rounded: "lg", fontFamily: "body", color: (0, react_2.useColorModeValue)("black", "white"), status: "success", flexDirection: "column", p: 0 },
        react_1.default.createElement(react_2.Box, { w: "full" },
            (loading || !image) && react_1.default.createElement(react_2.Skeleton, { w: "full", h: "327px" }),
            !loading && image && (react_1.default.createElement(react_2.Image, { objectFit: "cover", alt: metadata === null || metadata === void 0 ? void 0 : metadata.data.name, w: "full", minH: "327px", src: image }))),
        react_1.default.createElement(react_2.VStack, { align: "left", w: "full", p: 8, spacing: 1, borderWidth: "2px", borderTopWidth: 0, borderBottomRadius: "8px", borderColor: (0, react_2.useColorModeValue)("gray.200", "black.300") },
            react_1.default.createElement(react_2.HStack, { align: "left", spacing: 1 },
                react_1.default.createElement(react_2.AlertTitle, { fontSize: "24px", fontWeight: 700 }, "Success!"),
                react_1.default.createElement(react_2.AlertIcon, null)),
            react_1.default.createElement(react_2.Text, { color: "gray.400" }, loading
                ? "Waiting on your preview..."
                : `Here is a preview of ${metadata === null || metadata === void 0 ? void 0 : metadata.data.name}`)),
        react_1.default.createElement(react_2.CloseButton, { position: "absolute", right: "8px", top: "8px", color: (0, react_2.useColorModeValue)("gray.600", "gray.400"), _hover: { color: "gray.600", cursor: "pointer" }, onClick: onDismiss })));
};
exports.MintedNftNotification = MintedNftNotification;
//# sourceMappingURL=MintedNftNotification.js.map