"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCandyMachineInfo = void 0;
const anchor = __importStar(require("@coral-xyz/anchor"));
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const react_1 = require("@strata-foundation/react");
const react_2 = require("react");
const components_1 = require("../components");
const useCandyMachine_1 = require("./useCandyMachine");
function useCandyMachineInfo(candyMachineId) {
    const [candyMachine, setCandyMachine] = (0, react_2.useState)();
    const [isActive, setIsActive] = (0, react_2.useState)(false);
    const [endDate, setEndDate] = (0, react_2.useState)();
    const [itemsRemaining, setItemsRemaining] = (0, react_2.useState)();
    const [isWhitelistUser, setIsWhitelistUser] = (0, react_2.useState)(false);
    const [isPresale, setIsPresale] = (0, react_2.useState)(false);
    const [discountPrice, setDiscountPrice] = (0, react_2.useState)();
    const { connection } = (0, wallet_adapter_react_1.useConnection)();
    const { publicKey } = (0, wallet_adapter_react_1.useWallet)();
    const { info: cndy } = (0, useCandyMachine_1.useCandyMachine)(candyMachineId);
    const unixTime = (0, react_1.useSolanaUnixTime)();
    (0, react_2.useEffect)(() => {
        (() => __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c;
            if (cndy && publicKey) {
                try {
                    let active = ((_a = cndy === null || cndy === void 0 ? void 0 : cndy.goLiveDate) === null || _a === void 0 ? void 0 : _a.toNumber()) < (unixTime || new Date().getTime() / 1000);
                    let presale = false;
                    // whitelist mint?
                    if (cndy === null || cndy === void 0 ? void 0 : cndy.whitelistMintSettings) {
                        // is it a presale mint?
                        if (cndy.whitelistMintSettings.presale &&
                            (!cndy.goLiveDate ||
                                cndy.goLiveDate.toNumber() > new Date().getTime() / 1000)) {
                            presale = true;
                        }
                        // is there a discount?
                        if (cndy.whitelistMintSettings.discountPrice) {
                            setDiscountPrice(cndy.whitelistMintSettings.discountPrice);
                        }
                        else {
                            setDiscountPrice(undefined);
                            // when presale=false and discountPrice=null, mint is restricted
                            // to whitelist users only
                            if (!cndy.whitelistMintSettings.presale) {
                                cndy.isWhitelistOnly = true;
                            }
                        }
                        // retrieves the whitelist token
                        const mint = new anchor.web3.PublicKey(cndy.whitelistMintSettings.mint);
                        const token = (yield (0, components_1.getAtaForMint)(mint, publicKey))[0];
                        try {
                            const balance = yield connection.getTokenAccountBalance(token);
                            let valid = parseInt(balance.value.amount) > 0;
                            // only whitelist the user if the balance > 0
                            setIsWhitelistUser(valid);
                            active = (presale && valid) || active;
                        }
                        catch (e) {
                            setIsWhitelistUser(false);
                            // no whitelist user, no mint
                            if (cndy.isWhitelistOnly) {
                                active = false;
                            }
                            console.log("There was a problem fetching whitelist token balance");
                            console.log(e);
                        }
                    }
                    // datetime to stop the mint?
                    if ((_b = cndy === null || cndy === void 0 ? void 0 : cndy.endSettings) === null || _b === void 0 ? void 0 : _b.endSettingType.date) {
                        setEndDate((0, components_1.toDate)(cndy.endSettings.number));
                        if (cndy.endSettings.number.toNumber() <
                            new Date().getTime() / 1000) {
                            active = false;
                        }
                    }
                    // amount to stop the mint?
                    if ((_c = cndy === null || cndy === void 0 ? void 0 : cndy.endSettings) === null || _c === void 0 ? void 0 : _c.endSettingType.amount) {
                        let limit = Math.min(cndy.endSettings.number.toNumber(), cndy.itemsAvailable);
                        if (cndy.itemsRedeemed < limit) {
                            setItemsRemaining(limit - cndy.itemsRedeemed);
                        }
                        else {
                            setItemsRemaining(0);
                            cndy.isSoldOut = true;
                        }
                    }
                    else {
                        setItemsRemaining(cndy.itemsRemaining);
                    }
                    if (cndy.isSoldOut) {
                        active = false;
                    }
                    setIsActive((cndy.isActive = active));
                    setIsPresale((cndy.isPresale = presale));
                    setCandyMachine(cndy);
                }
                catch (e) {
                    console.log("There was a problem fetching Candy Machine state");
                    console.log(e);
                }
            }
        }))();
    }, [publicKey, cndy, connection, unixTime]);
    return {
        candyMachine,
        isActive,
        endDate,
        itemsRemaining,
        isWhitelistUser,
        isPresale,
        discountPrice,
    };
}
exports.useCandyMachineInfo = useCandyMachineInfo;
//# sourceMappingURL=useCandyMachineInfo.js.map