/// <reference types="@solana/web3.js" />
import * as anchor from "@coral-xyz/anchor";
import BN from "bn.js";
export interface AlertState {
    open: boolean;
    message: string;
    severity: "success" | "info" | "warning" | "error" | undefined;
}
export declare const toDate: (value?: BN) => Date;
export declare const formatNumber: {
    format: (val?: number) => string;
    asNumber: (val?: BN) => number;
};
export declare const SPL_ASSOCIATED_TOKEN_ACCOUNT_PROGRAM_ID: anchor.web3.PublicKey;
export declare const CIVIC: anchor.web3.PublicKey;
export declare const getAtaForMint: (mint: anchor.web3.PublicKey, buyer: anchor.web3.PublicKey) => Promise<[anchor.web3.PublicKey, number]>;
export declare const getNetworkExpire: (gatekeeperNetwork: anchor.web3.PublicKey) => Promise<[anchor.web3.PublicKey, number]>;
export declare const getNetworkToken: (wallet: anchor.web3.PublicKey, gatekeeperNetwork: anchor.web3.PublicKey) => Promise<[anchor.web3.PublicKey, number]>;
export declare function createAssociatedTokenAccountInstruction(associatedTokenAddress: anchor.web3.PublicKey, payer: anchor.web3.PublicKey, walletAddress: anchor.web3.PublicKey, splTokenMintAddress: anchor.web3.PublicKey): anchor.web3.TransactionInstruction;
//# sourceMappingURL=utils.d.ts.map